Package org.apache.sysds.runtime.compress.colgroup

## Class ColGroupSDCFOR

- java.lang.Object
- - org.apache.sysds.runtime.compress.colgroup.AColGroup
  - - org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed
    - - org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup
      - - org.apache.sysds.runtime.compress.colgroup.AColGroupValue
        - - org.apache.sysds.runtime.compress.colgroup.AMorphingMMColGroup
          - - org.apache.sysds.runtime.compress.colgroup.ASDC
            - - org.apache.sysds.runtime.compress.colgroup.ColGroupSDCFOR

All Implemented Interfaces:
  `Serializable`, `AMapToDataGroup`, `AOffsetsGroup`

    public class ColGroupSDCFOR
    extends ASDC
    implements AMapToDataGroup

ColGroup for Patched Frame Of Reference. This column group fits perfectly into the collection of compression groups It can be constructed when a SDCZeros group get a non zero default value. Then a natural extension is to transform the group into a PFOR group, since the default value is then treated as an offset, and the dictionary can be copied with no modifications.

See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`AColGroup.CompressionType`

### Method Summary

All Methods Static Methods Instance Methods Concrete Methods
`AColGroup` `append​(AColGroup g)` Append the other column group to this column group.
`AColGroup` `appendNInternal​(AColGroup[] g)`
`AColGroup` `binaryRowOpLeft​(BinaryOperator op, double[] v, boolean isRowSafe)` Perform a binary row operation.
`AColGroup` `binaryRowOpRight​(BinaryOperator op, double[] v, boolean isRowSafe)` Perform a binary row operation.
`CM_COV_Object` `centralMoment​(CMOperator op, int nRows)` Central Moment instruction executed on a column group.
`void` `computeColSums​(double[] c, int nRows)` Compute the column sum
`boolean` `containsValue​(double pattern)` Detect if the column group contains a specific value.
`static AColGroup` `create​(IColIndex colIndexes, int numRows, ADictionary dict, AOffset offsets, AMapToData data, int[] cachedCounts, double[] reference)`
`long` `estimateInMemorySize()` Get the upper bound estimate of in memory allocation for the column group.
`AColGroup` `extractCommon​(double[] constV)` extract common value from group and return non morphing group
`org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType` `getColGroupType()`
`double[]` `getCommon()` Get common vector, note this should not materialize anything but simply point to things that are already allocated.
`ICLAScheme` `getCompressionScheme()` Get the compression scheme for this column group to enable compression of other data.
`AColGroup.CompressionType` `getCompType()` Obtain the compression type.
`double` `getCost​(ComputationCostEstimator e, int nRows)` Get the computation cost associated with this column group.
`int[]` `getCounts​(int[] counts)`
`double[]` `getDefaultTuple()`
`long` `getExactSizeOnDisk()` Returns the exact serialized size of column group.
`double` `getIdx​(int r, int colIdx)` Get the value at a colGroup specific row/column index position.
`AMapToData` `getMapToData()`
`long` `getNumberNonZeros​(int nRows)` Get the number of nonZeros contained in this column group.
`static ColGroupSDCFOR` `read​(DataInput in, int nRows)`
`AColGroup` `replace​(double pattern, double replace)` Make a copy of the column group values, and replace all values that match pattern with replacement value.
`AColGroup` `rexpandCols​(int max, boolean ignore, boolean cast, int nRows)` Expand the column group to multiple columns.
`AColGroup` `scalarOperation​(ScalarOperator op)` Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.
`AColGroup` `sliceRows​(int rl, int ru)` Slice range of rows out of the column group and return a new column group only containing the row segment.
`static AColGroup` `sparsifyFOR​(ColGroupSDC g)`
`String` `toString()`
`AColGroup` `unaryOperation​(UnaryOperator op)` Perform unary operation on the column group and return a new column group
`void` `write​(DataOutput out)`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.ASDC

`getNumRows, getOffsets`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AMorphingMMColGroup

`leftMultByAColGroup, leftMultByMatrixNoPreAgg, tsmmAColGroup`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupValue

`getCounts, getNumValues`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.ADictBasedColGroup

`decompressToDenseBlock, decompressToSparseBlock, getDictionary, rightMultByMatrix`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroupCompressed

`getMax, getMin, getSum, isEmpty, preAggRows, tsmm, unaryAggregateOperations, unaryAggregateOperations`

### Methods inherited from class org.apache.sysds.runtime.compress.colgroup.AColGroup

`appendN, colSum, decompressToDenseBlock, decompressToSparseBlock, get, getColIndices, getNumCols, rightMultByMatrix, shiftColIndices, sliceColumn, sliceColumns`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### create

    public static AColGroup create​(IColIndex colIndexes,
                                   int numRows,
                                   ADictionary dict,
                                   AOffset offsets,
                                   AMapToData data,
                                   int[] cachedCounts,
                                   double[] reference)

#### sparsifyFOR

    public static AColGroup sparsifyFOR​(ColGroupSDC g)

#### getCompType

    public AColGroup.CompressionType getCompType()

Description copied from class: `AColGroup`
Obtain the compression type.

Specified by:
  `getCompType` in class `AColGroup`
Returns:
  How the elements of the column group are compressed.

#### getColGroupType

    public org.apache.sysds.runtime.compress.colgroup.AColGroup.ColGroupType getColGroupType()

#### getDefaultTuple

    public double[] getDefaultTuple()

Specified by:
  `getDefaultTuple` in class `ASDC`

#### getCounts

    public int[] getCounts​(int[] counts)

#### getMapToData

    public AMapToData getMapToData()

Specified by:
  `getMapToData` in interface `AMapToDataGroup`

#### getIdx

    public double getIdx​(int r,
                         int colIdx)

Description copied from class: `AColGroup`
Get the value at a colGroup specific row/column index position.

Specified by:
  `getIdx` in class `AColGroup`
Parameters:
  `r` - row
  `colIdx` - column index in the _colIndexes.
Returns:
  value at the row/column index position

#### scalarOperation

    public AColGroup scalarOperation​(ScalarOperator op)

Description copied from class: `AColGroup`
Perform the specified scalar operation directly on the compressed column group, without decompressing individual cells if possible.

Specified by:
  `scalarOperation` in class `AColGroup`
Parameters:
  `op` - operation to perform
Returns:
  version of this column group with the operation applied

#### unaryOperation

    public AColGroup unaryOperation​(UnaryOperator op)

Description copied from class: `AColGroup`
Perform unary operation on the column group and return a new column group

Specified by:
  `unaryOperation` in class `AColGroup`
Parameters:
  `op` - The operation to perform
Returns:
  The new column group

#### binaryRowOpLeft

    public AColGroup binaryRowOpLeft​(BinaryOperator op,
                                     double[] v,
                                     boolean isRowSafe)

Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpLeft` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply, should be same length as dictionary length.
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

#### binaryRowOpRight

    public AColGroup binaryRowOpRight​(BinaryOperator op,
                                      double[] v,
                                      boolean isRowSafe)

Description copied from class: `AColGroup`
Perform a binary row operation.

Specified by:
  `binaryRowOpRight` in class `AColGroup`
Parameters:
  `op` - The operation to execute
  `v` - The vector of values to apply, should be same length as dictionary length.
  `isRowSafe` - True if the binary op is applied to an entire zero row and all results are zero
Returns:
  A updated column group with the new values.

#### write

    public void write​(DataOutput out)
               throws IOException

Overrides:
  `write` in class `ADictBasedColGroup`
Throws:
  `IOException`

#### read

    public static ColGroupSDCFOR read​(DataInput in,
                                      int nRows)
                               throws IOException

Throws:
  `IOException`

#### getExactSizeOnDisk

    public long getExactSizeOnDisk()

Description copied from class: `AColGroup`
Returns the exact serialized size of column group. This can be used for example for buffer preallocation.

Overrides:
  `getExactSizeOnDisk` in class `ADictBasedColGroup`
Returns:
  exact serialized size for column group

#### estimateInMemorySize

    public long estimateInMemorySize()

Description copied from class: `AColGroup`
Get the upper bound estimate of in memory allocation for the column group.

Overrides:
  `estimateInMemorySize` in class `AColGroupValue`
Returns:
  an upper bound on the number of bytes used to store this ColGroup in memory.

#### replace

    public AColGroup replace​(double pattern,
                             double replace)

Description copied from class: `AColGroup`
Make a copy of the column group values, and replace all values that match pattern with replacement value.

Overrides:
  `replace` in class `AColGroupValue`
Parameters:
  `pattern` - The value to look for
  `replace` - The value to replace the other value with
Returns:
  A new Column Group, reusing the index structure but with new values.

#### computeColSums

    public void computeColSums​(double[] c,
                               int nRows)

Description copied from class: `AColGroup`
Compute the column sum

Overrides:
  `computeColSums` in class `AColGroupValue`
Parameters:
  `c` - The array to add the column sum to.
  `nRows` - The number of rows in the column group.

#### containsValue

    public boolean containsValue​(double pattern)

Description copied from class: `AColGroup`
Detect if the column group contains a specific value.

Specified by:
  `containsValue` in class `AColGroup`
Parameters:
  `pattern` - The value to look for.
Returns:
  boolean saying true if the value is contained.

#### getNumberNonZeros

    public long getNumberNonZeros​(int nRows)

Description copied from class: `AColGroup`
Get the number of nonZeros contained in this column group.

Overrides:
  `getNumberNonZeros` in class `AColGroupValue`
Parameters:
  `nRows` - The number of rows in the column group, this is used for groups that does not contain information about how many rows they have.
Returns:
  The nnz.

#### extractCommon

    public AColGroup extractCommon​(double[] constV)

Description copied from class: `AMorphingMMColGroup`
extract common value from group and return non morphing group

Specified by:
  `extractCommon` in class `AMorphingMMColGroup`
Parameters:
  `constV` - a vector to contain all values, note length = nCols in total matrix.
Returns:
  A non morphing column group with decompression instructions.

#### rexpandCols

    public AColGroup rexpandCols​(int max,
                                 boolean ignore,
                                 boolean cast,
                                 int nRows)

Description copied from class: `AColGroup`
Expand the column group to multiple columns. (one hot encode the column group)

Overrides:
  `rexpandCols` in class `AColGroupValue`
Parameters:
  `max` - The number of columns to expand to and cutoff values at.
  `ignore` - If zero and negative values should be ignored.
  `cast` - If the double values contained should be cast to whole numbers.
  `nRows` - The number of rows in the column group.
Returns:
  A new column group containing max number of columns.

#### centralMoment

    public CM_COV_Object centralMoment​(CMOperator op,
                                       int nRows)

Description copied from class: `AColGroup`
Central Moment instruction executed on a column group.

Overrides:
  `centralMoment` in class `AColGroupValue`
Parameters:
  `op` - The Operator to use.
  `nRows` - The number of rows contained in the ColumnGroup.
Returns:
  A Central Moment object.

#### getCost

    public double getCost​(ComputationCostEstimator e,
                          int nRows)

Description copied from class: `AColGroup`
Get the computation cost associated with this column group.

Specified by:
  `getCost` in class `AColGroup`
Parameters:
  `e` - The computation cost estimator
  `nRows` - the number of rows in the column group
Returns:
  The cost of this column group

#### getCommon

    public double[] getCommon()

Description copied from class: `AMorphingMMColGroup`
Get common vector, note this should not materialize anything but simply point to things that are already allocated.

Specified by:
  `getCommon` in class `AMorphingMMColGroup`
Returns:
  the common double vector

#### sliceRows

    public AColGroup sliceRows​(int rl,
                               int ru)

Description copied from class: `AColGroup`
Slice range of rows out of the column group and return a new column group only containing the row segment. Note that this slice should maintain pointers back to the original dictionaries and only modify index structures.

Specified by:
  `sliceRows` in class `AColGroup`
Parameters:
  `rl` - The row to start at
  `ru` - The row to end at (not included)
Returns:
  A new column group containing the specified row range.

#### append

    public AColGroup append​(AColGroup g)

Description copied from class: `AColGroup`
Append the other column group to this column group. This method tries to combine them to return a new column group containing both. In some cases it is possible in reasonable time, in others it is not. The result is first this column group followed by the other column group in higher row values. If it is not possible or very inefficient null is returned.

Specified by:
  `append` in class `AColGroup`
Parameters:
  `g` - The other column group
Returns:
  A combined column group or null

#### appendNInternal

    public AColGroup appendNInternal​(AColGroup[] g)

#### getCompressionScheme

    public ICLAScheme getCompressionScheme()

Description copied from class: `AColGroup`
Get the compression scheme for this column group to enable compression of other data.

Specified by:
  `getCompressionScheme` in class `AColGroup`
Returns:
  The compression scheme of this column group

#### toString

    public String toString()

Overrides:
  `toString` in class `AColGroupValue`